import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class combiMatch extends PApplet {

Table table;
ArrayList<String> profilsArray;
int[] nRepetProfils;
int rectX, rectY;      // Position of square button
int rectSize = 90;     // Diameter of rect
int rectColor, circleColor, baseColor;
int rectHighlight, circleHighlight;
int currentColor;
boolean rectOver = false;
boolean isDone = false;
PFont f;

public void setup() {
  
  f = createFont("Arial",16,true); // Arial, 16 point, anti-aliasing on
  textFont(f,36);
  fill(255);
  rectColor = color(0);
  rectHighlight = color(51);
  circleColor = color(255);
  circleHighlight = color(204);
  baseColor = color(240);
  currentColor = baseColor;
  rectX = width/2-rectSize/2;
  rectY = height/2-rectSize/2;
  ellipseMode(CENTER);
  
  
}

public void draw() {
  update(mouseX, mouseY);
  background(currentColor);
  
  if (rectOver) {
    fill(rectHighlight);
  } else {
    fill(rectColor);
  }
  stroke(255);
  rect(rectX, rectY, rectSize, rectSize);
  
  stroke(0);
  
  if(isDone){
    text("C'est fini. Le fichier se trouve dans le r\u00e9petoire 'data'. \nCliquez sur le carr\u00e9 pour quitter.",10,100);
  }
  else{
    text("Cliquez sur le carr\u00e9 pour selectionner un fichier (.csv).",10,100);
  }
  

}
public void update(int x, int y) {
  if ( overRect(rectX, rectY, rectSize, rectSize) ) {
    rectOver = true;
  } else {
    rectOver = false;
  }
}

public void mousePressed() {
  if (rectOver) {
    currentColor = rectColor;
    if (isDone){
      exit();
    }
    else {
      selectInput("Selectionnez un fichier .csv :", "fileSelected");
    }
   
  }
}

public boolean overRect(int x, int y, int width, int height)  {
  if (mouseX >= x && mouseX <= x+width && 
      mouseY >= y && mouseY <= y+height) {
    return true;
  } else {
    return false;
  }
}

public boolean overCircle(int x, int y, int diameter) {
  float disX = x - mouseX;
  float disY = y - mouseY;
  if (sqrt(sq(disX) + sq(disY)) < diameter/2 ) {
    return true;
  } else {
    return false;
  }
}


///////////////////

public void fileSelected(File selection) {
  if (selection == null) {
    //println("Window was closed or the user hit cancel.");
    currentColor = baseColor;
  } else {
    println("User selected " + selection.getAbsolutePath());
    combinaiMatch(selection.getAbsolutePath());
  }
}


public void combinaiMatch(String file){
  table = loadTable(file, "header");
  //println(table.getRowCount() + " total rows in table");
  profilsArray=new ArrayList<String>();
  nRepetProfils= new int[table.getRowCount()];

  for (int i = 0; i<table.getRowCount(); i++) {
    // reference
    TableRow row = table.getRow(i);
    String tp = "";
    for ( int col = 0, num = row.getColumnCount(); col != num;){
      tp=tp+row.getString(col++);
    }
    profilsArray.add(tp);
  }
  // Compare Ref To profilsArray
  for ( int x = 0, num = nRepetProfils.length; x != num;){
    nRepetProfils[x]=0;
    String refString=profilsArray.get(x);
    for ( int y = 0, num2 = profilsArray.size(); y != num2;){
      if(profilsArray.get(y).equals(refString))
      {
        //profilsArray.remove(y);
        nRepetProfils[x]=nRepetProfils[x]+1;
      }
      y++;
    }
    x++;
  }
  // Register nRepet & new list
  table.addColumn("nRepet");
  table.addColumn("Doublon");
   for (int i = 0; i<table.getRowCount(); i++) {
    TableRow row = table.getRow(i);
    row.setInt("nRepet",nRepetProfils[i]);
    row.setString("Doublon","False");
  }
  profilsArray=new ArrayList<String>();
   for (int i = 0; i<table.getRowCount(); i++) {
    // reference
    TableRow row = table.getRow(i);
    String tp = "";
    for ( int col = 0, num = row.getColumnCount(); col != num;){
      tp=tp+row.getString(col++);
    }
    profilsArray.add(tp);
  }
  
  //saveTable(table, "data/result.csv","csv");
  
  // suprime doublon table
  for ( int x = 0, num = profilsArray.size(); x != num;){
    String refString=profilsArray.get(x);
    for ( int y = x+1, num2 = profilsArray.size(); y < num2;){
      if(profilsArray.get(y).equals(refString))
      {
        //profilsArray.remove(y);
        TableRow row = table.getRow(y);
        row.setString("Doublon","True");
      }
      y++;
    }
    x++;
  }
   saveTable(table, "data/result.csv","csv");
    currentColor = baseColor;
   isDone=true;
}
  public void settings() {  size(1280, 640); }
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "combiMatch" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
